#_________________________________________________
# Task 4: Use potentiometer to control motor

import pyb
from pyb import Pin, Timer, ADC
print('Task 4: Use potentiometer to control motor speed')

# define various I/O pin for ADC
pot = ADC(Pin('X8'))

# Use Y9 and Y10 for direction control of motor
A1 = Pin('Y9',Pin.OUT_PP)
A2 = Pin('Y10',Pin.OUT_PP)
# Use X1 for speed control of motor using PWM
pwm_out = Pin('X1')

# Configure counter 2 to produce 1kHz clock signal
tim = Timer(2, freq = 1000)
# Configure timer to provide PWM signal
motor = tim.channel(1, Timer.PWM, pin = pwm_out)

# initially set motor to brake	
A1.high()
A2.high()

MID = 2048
DEADZONE = 10
# Use joystick to control forward/backward and speed
while True:				# loop forever until CTRL-C
	speed = int(100*(pot.read()-MID)/MID)
	if (speed > DEADZONE):		# forward
		A1.high()
		A2.low()
		motor.pulse_width_percent(speed)
	elif (speed < -DEADZONE):
		A1.low()		# backward
		A2.high()
		motor.pulse_width_percent(abs(speed))
	else:
		A1.low()		# stop
		A2.low()		
